bl_info = {
    "name" : "Road Draw ",
    "author" : "CGBlender", 
    "description" : "Road Draw Add-on is a blender addon, that allows you to draw and generate roads around a simple environment scene or stones on any surface you want, and it comes with different roads style.",
    "blender" : (3, 3, 0),
    "version" : (1, 0, 0),
    "location" : "",
    "waring" : "",
    "doc_url": "", 
    "tracker_url": "", 
    "category" : "3D View" 
}


import bpy
import bpy.utils.previews

import os
import os
import os
import os
import os
import os
import os
import os
import os
import os
import os
import os
import os
import os
import os
import os
import os
import os
import os
import os
import os


def string_to_int(value):
    if value.isdigit():
        return int(value)
    return 0

def string_to_icon(value):
    if value in bpy.types.UILayout.bl_rna.functions["prop"].parameters["icon"].enum_items.keys():
        return bpy.types.UILayout.bl_rna.functions["prop"].parameters["icon"].enum_items[value].value
    return string_to_int(value)
    
def icon_to_string(value):
    for icon in bpy.types.UILayout.bl_rna.functions["prop"].parameters["icon"].enum_items:
        if icon.value == value:
            return icon.name
    return "NONE"
    
def enum_set_to_string(value):
    if type(value) == set:
        if len(value) > 0:
            return "[" + (", ").join(list(value)) + "]"
        return "[]"
    return value
    
def string_to_type(value, to_type, default):
    try:
        value = to_type(value)
    except:
        value = default
    return value

addon_keymaps = {}
_icons = None
road_draw_ = {}


def sna_update_sna_roads_drawp_8A609(self, context):
    sna_updated_prop = self.sna_roads_drawp
    bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'Roads Draw.blend') + r'\Object', filename=sna_updated_prop, link=False)
    for i_95C67 in range(len(bpy.context.view_layer.objects.selected)):
        if bpy.context.view_layer.objects.selected[i_95C67].select_get():
            bpy.context.view_layer.objects.active = bpy.context.view_layer.objects.selected[i_95C67]
        else:
            pass
_item_map = dict()
def make_enum_item(_id, name, descr, preview_id, uid):
    lookup = str(_id)+"\0"+str(name)+"\0"+str(descr)+"\0"+str(preview_id)+"\0"+str(uid)
    if not lookup in _item_map:
        _item_map[lookup] = (_id, name, descr, preview_id, uid)
    return _item_map[lookup]
def load_preview_icon(path):
    global _icons
    if not path in _icons:
        if os.path.exists(path):
            _icons.load(path, path, "IMAGE")
        else:
            return 0
    return _icons[path].icon_id
def load_preview_icon(path):
    global _icons
    if not path in _icons:
        if os.path.exists(path):
            _icons.load(path, path, "IMAGE")
        else:
            return 0
    return _icons[path].icon_id
def load_preview_icon(path):
    global _icons
    if not path in _icons:
        if os.path.exists(path):
            _icons.load(path, path, "IMAGE")
        else:
            return 0
    return _icons[path].icon_id
def load_preview_icon(path):
    global _icons
    if not path in _icons:
        if os.path.exists(path):
            _icons.load(path, path, "IMAGE")
        else:
            return 0
    return _icons[path].icon_id
def load_preview_icon(path):
    global _icons
    if not path in _icons:
        if os.path.exists(path):
            _icons.load(path, path, "IMAGE")
        else:
            return 0
    return _icons[path].icon_id
def load_preview_icon(path):
    global _icons
    if not path in _icons:
        if os.path.exists(path):
            _icons.load(path, path, "IMAGE")
        else:
            return 0
    return _icons[path].icon_id
def load_preview_icon(path):
    global _icons
    if not path in _icons:
        if os.path.exists(path):
            _icons.load(path, path, "IMAGE")
        else:
            return 0
    return _icons[path].icon_id
def load_preview_icon(path):
    global _icons
    if not path in _icons:
        if os.path.exists(path):
            _icons.load(path, path, "IMAGE")
        else:
            return 0
    return _icons[path].icon_id
def load_preview_icon(path):
    global _icons
    if not path in _icons:
        if os.path.exists(path):
            _icons.load(path, path, "IMAGE")
        else:
            return 0
    return _icons[path].icon_id
def load_preview_icon(path):
    global _icons
    if not path in _icons:
        if os.path.exists(path):
            _icons.load(path, path, "IMAGE")
        else:
            return 0
    return _icons[path].icon_id

def sna_roads_drawp_enum_items(self, context):
    enum_items = [['r1', 'r1', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'r1.png'))], ['r2', 'r2', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'r2.png'))], ['r3', 'r3', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'r3.png'))], ['r4', 'r4', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'r4.png'))], ['r5', 'r5', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'r5.png'))], ['r6', 'r6', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'r6.png'))], ['r7', 'r7', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'r7.png'))], ['r8', 'r8', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'r8.png'))], ['r9', 'r9', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'r9.png'))], ['r10', 'r10', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'r10.png'))]]
    return [make_enum_item(item[0], item[1], item[2], item[3], i) for i, item in enumerate(enum_items)]
class SNA_PT_ROAD_DRAW__1AC0C(bpy.types.Panel):
    bl_label = 'Road Draw '
    bl_idname = 'SNA_PT_ROAD_DRAW__1AC0C'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_context = ''
    bl_category = 'RD'
    bl_order = 0
    
    
    @classmethod
    def poll(cls, context):
        return not (False)
    
    def draw_header(self, context):
        layout = self.layout
        
    def draw(self, context):
        layout = self.layout
        layout.template_icon_view(bpy.context.scene, 'sna_roads_drawp', show_labels=False, scale=5.0, scale_popup=5.0)
        col_D4908 = layout.column(heading='', align=False)
        col_D4908.alert = False
        col_D4908.enabled = True
        col_D4908.use_property_split = False
        col_D4908.use_property_decorate = False
        col_D4908.scale_x = 1.0
        col_D4908.scale_y = 1.0
        col_D4908.alignment = 'Expand'.upper()
        col_D4908.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Quadrilateral'].inputs[0], 'default_value', text='Wall Width', icon_value=0, emboss=True)
        col_D4908.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Quadrilateral'].inputs[1], 'default_value', text='Wall Height', icon_value=0, emboss=True)
        




def register():
    
    global _icons
    _icons = bpy.utils.previews.new()
    bpy.types.Scene.sna_roads_drawp = bpy.props.EnumProperty(name='Roads Drawp', description='', items=sna_roads_drawp_enum_items, update=sna_update_sna_roads_drawp_8A609)
    
    
    bpy.utils.register_class(SNA_PT_ROAD_DRAW__1AC0C)

def unregister():
    
    global _icons
    bpy.utils.previews.remove(_icons)
    
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    for km, kmi in addon_keymaps.values():
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()
    del bpy.types.Scene.sna_roads_drawp
    
    
    bpy.utils.unregister_class(SNA_PT_ROAD_DRAW__1AC0C)

